

/* 
   orxonox - the future of 3D-vertical-scrollers

   Copyright (C) 2004 orx

   This program is free software; you can redistribute it and/or modify
   it under the terms of the GNU General Public License as published by
   the Free Software Foundation; either version 2, or (at your option)
   any later version.

   ### File Specific:
   main-programmer: Patrick Boenzli
   co-programmer: 
*/


#include "glmenu_imagescreen.h"
#include "importer/texture.h"

using namespace std;


/**
   \brief standard constructor

   \todo this constructor is not jet implemented - do it
*/
GLMenuImageScreen::GLMenuImageScreen () 
{
   this->setClassName ("GLMenuImageScreen");
}


/**
   \brief standard deconstructor

   \todo this deconstructor is not jet implemented - do it
*/
GLMenuImageScreen::~GLMenuImageScreen () {}


/**
   \brief function to init the screen
*/
void GLMenuImageScreen::init ()
{
  /*
  int w = 680;
  int h = 480;

  glViewport(0,0,w,h);
  
  glMatrixMode(GL_PROJECTION);
  glLoadIdentity(); 
  gluPerspective(45.0f,(GLfloat)w/(GLfloat)h, .5f ,150.0f);
  glMatrixMode(GL_MODELVIEW); 

  this->backTex = new Texture();
  this->backTex->loadImage("orx_tex.bmp");

  glClear(GL_COLOR_BUFFER_BIT | GL_DEPTH_BUFFER_BIT);
  glLoadIdentity();
  gluLookAt(0, 0, 6,     0, 0, 0,     0, 1, 0);

  // Bind the texture stored at the zero index of g_Texture[]
  //glBindTexture(GL_TEXTURE_2D, g_Texture[0]);
  */

  int e_bnd=0,b0=0,BANDS=64,j=0,k=0; // 0 = 32 band and 1 = 64 band.
  int red,green,blue,alpha=100;
  
  float vuX,vuY;
  long x;
  float gap=7.915f; // for default
  double equVal,y1=0;
  float AV_peak_falloff = 0.8f; // Spead the Peaks fall.
  
  int n;
  
  // Screen Size.
  int screen_width = 640;
  int screen_height = 480;
  
  // Set Image Size.
  int hud_width = 50;
  int hud_height = 50;
  
  // Start pos of image.
  int hud_x = 10;
  int hud_y = 10;
  
  glEnable(GL_BLEND);
  glEnable(GL_TEXTURE_2D);
  
  // Select Our VU Meter Background Texture
  this->backTex = new Texture();
  this->backTex->loadImage("orx_tex.bmp");
  glPushAttrib(GL_LIGHTING_BIT | GL_TRANSFORM_BIT);
  
  glDisable(GL_LIGHTING);
  glMatrixMode(GL_PROJECTION);
  glPushMatrix();
  glLoadIdentity();
  glOrtho(0,screen_width,0,screen_height,-1,1); // Set Up An Ortho Screen
  glMatrixMode(GL_MODELVIEW);
  glLoadIdentity();
  glPushMatrix();
  glEnable(GL_BLEND);

  glBegin(GL_QUADS);
  glTexCoord2i(0, 0); glVertex2i(hud_x, hud_y);
  glTexCoord2i(1, 0 ); glVertex2i( hud_x+hud_width, hud_y );
  glTexCoord2i( 1, 1 ); glVertex2i( hud_x+hud_width, hud_y+hud_height );
  glTexCoord2i( 0, 1 ); glVertex2i( hud_x, hud_y+hud_height );
  glEnd();

  glDisable(GL_BLEND);
  glPopMatrix();
  glMatrixMode(GL_PROJECTION);
  glPopMatrix();
  glPopAttrib();
  glDisable(GL_TEXTURE_2D);
  glDisable(GL_BLEND);
  // End of Background image code.
}


/**
   \brief function to innit screen with all attributes set
   \param name of the background-image file
   \param height of the ImageScreen
   \param width of the Image Screen
   \param x offset from (0, 0)
   \param y offset from (0, 0)

   GLMenu uses its own coordinating system: upper left corner is (0, 0). x-axis is down=height, 
   right axis is right direction (=width)
*/
void GLMenuImageScreen::init (char* backImageName, float height, float width, 
			      float offsetX, float offsetY)
{}


/**
   \brief draws the ImageScreen to the screenbuffer
*/
void GLMenuImageScreen::draw ()
{
  /*
  // Display a quad texture to the screen
  glEnable(GL_TEXTURE_2D);
  glBegin(GL_QUADS);
  
  // Display the top left vertice
  glTexCoord2f(0.0f, 1.0f);
  glVertex3f(-2.5, 2.5, 0);
  
  // Display the bottom left vertice
  glTexCoord2f(0.0f, 0.0f);
  glVertex3f(-2.5, -2.5, 0);
  
  // Display the bottom right vertice
  glTexCoord2f(1.0f, 0.0f);
  glVertex3f(2.5, -2.5, 0);
  
  // Display the top right vertice
  glTexCoord2f(1.0f, 1.0f);
  glVertex3f(2.5, 2.5, 0);

  glEnd();
  glEnable(GL_TEXTURE_2D);  
  */
  
  SDL_GL_SwapBuffers();                    

  delete this->backTex;
  SDL_Delay(5000);
}

 
/** 
    \brief sets the background image name
    \param file name of the backgroun-image
 */
void GLMenuImageScreen::setBackImageName (char* backImageName)
{}


/**
   \brief sets position of the ImageScreen
   \param x offset from (0, 0)
   \param y offset from (0, 0)
*/
void GLMenuImageScreen::setPosition(float offsetX, float offsetY)
{}


/*
  \brief sets size of the ImageScreen
  \param height of the ImageScreen
  \param width of the Image Screen
*/
void GLMenuImageScreen::setSize(float height, float width)
{}
